module Escalator

  class Command < CLAide::Command

    require_relative "command/confuse"
    require_relative "command/archive"
    require_relative "command/resign"
    require_relative "command/upload"
    require_relative "command/combine"
    require_relative "command/setup"

    self.abstract_command = true

    self.version = VERSION

    self.command = "escalator"

    self.description = <<-DESC
    本工具专为 testflight 上架多马甲包而生

    旨在取代马甲包代码频繁修改, 上传安装包繁杂的人工流程

    主要功能包含: 代码混淆, 项目打包, ipa重签名, ipa上传
    DESC

    DEFAULT_ROOT_OPTIONS = [
      ['--version', '仅输出工具版本号, 默认: 否'],
    ]

    DEFAULT_OPTIONS = [
      ['--verbose', '输出更多调试信息, 默认: 否'],
      ['--no-ansi', '关闭高亮输出模式, 默认: 否'],
      ['--help',    '仅输出指定命令的帮助文档, 默认: 否'],
    ]

    def self.options
      if root_command?
        DEFAULT_ROOT_OPTIONS + DEFAULT_OPTIONS
      else
        DEFAULT_OPTIONS
      end
    end

  end

end
